/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 22 de Enero de 2001

Simulacin:  AlgEvo001
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Dado un Universo, este esta lleno de ambientes, hay una serie de
elementos (materia) que reaccionan al estado del ambiente, una serie
de seres vivos comandados por el "algoritmo evolutivo", buscan conseguir
dichos elementos usando estratgias como desplazamiento, coleccin de nuevos
elementos, etc...

*/

#ifndef PARAMETRO
#include "Parametro.h"
#endif


#ifndef EVALUADOREXPRESIONES
#include "EvalExpr.h"
#endif

//Tipo de Material
class TipoMat
{
private:
	/* Como se comporta en el ambiente donde se encuentra en f(z) */
	char *m_sEcuacion;

	/* Evalua previamente la ecuacin para dar mayor velocidad */
	EvalExpr objEval;

public:
	/* Identificador de Tipo */
	unsigned int m_iIDtipo;

	/* Inicia el comportamiento del material */
	unsigned int iInicia(unsigned int iID,
		         unsigned int iLongExprTip,
				 unsigned int iProbN, unsigned int iProbX, unsigned int iProbP);

	/* Suma o resta energa dependiendo de como es el ambiente */
	signed int iEnergia(float fValAmbiente);
};
